import sys
import numpy as np
from math import *


def main():
    om = float(sys.argv[1])
    A = np.array([[4,-1,0,-1,0,0],[-1,4,-1,0,-1,0],[0,-1,4,0,0,-1],
    [-1,0,0,4,-1,0],[0,-1,0,-1,4,-1],[0,0,-1,0,-1,4]])
    D = np.diag(np.diag(A))
    L = np.zeros((6,6))
    for i in range(1,6):
        for j in range(0,i):
            L[i][j] = -A[i][j]
    U = np.zeros((6,6))
    for i in range(0,5):
        for j in range(i+1,6):
            U[i][j] = -A[i][j]
    T = np.dot(np.linalg.inv(D-om*L),(1-om)*D+om*U)
    rho = max(abs(np.linalg.eigvals(T)))
    print(rho)


main()
